#ifndef MY_STRING_HPP
#define MY_STRING_HPP

#include "ref_counted.hpp"
#include <cstring>
#include <iostream>

class my_string
{
private:
    ref_counted<char> stringData; // Manages the dynamically allocated string

public:
    // Constructor with C-string input
    my_string(const char *str)
        : stringData(new char[std::strlen(str) + 1])
    {
        std::strcpy(stringData.get(), str);
    }

    // Access a character by index
    char getChar(int i) const
    {
        return *(stringData.get() + i); // Use pointer arithmetic to access the character
    }

    // Modify a character by index
    void setChar(int i, char c)
    {
        *(stringData.get() + i) = c; // Use pointer arithmetic to modify the character
    }

    // Print the string with reference count
    void print() const
    {
        std::cout << stringData.get() << " [" << stringData.count() << "]" << std::endl;
    }
};

#endif
