#include "my_string.hpp"

void demonstrateReferenceCountZero()
{
    my_string temp("Temporary");
    temp.print(); // Output: Temporary [1]

    {
        my_string shared = temp;
        shared.print(); // Output: Temporary [2]
    } // 'shared' goes out of scope, reference count decreases

    temp.print(); // Output: Temporary [1]
    std::cout << "When temp goes out of scope, reference count becomes 0, and memory is freed." << std::endl;
}

int main()
{
    my_string s("Helloworld");
    s.print(); // Output: Helloworld [1]

    {
        my_string t = s;
        t.print(); // Output: Helloworld [2]
        s.print(); // Output: Helloworld [2]

        std::cout << s.getChar(1) << std::endl; // Output: e

        t.setChar(1, 'E'); // Modify t
        t.print();         // Output: HElloworld [1]
        s.print();         // Output: Helloworld [1]
    }

    demonstrateReferenceCountZero();

    return 0;
}
