#ifndef BENCHMARK_HPP
#define BENCHMARK_HPP

#include <chrono>
#include <iostream>
#include <functional>
#include <string>

class Benchmark {
public:
    // Function to measure the time of a void function
    static void measure(const std::string& name, const std::function<void()>& func) {
        using namespace std::chrono;
        auto start = high_resolution_clock::now();
        func(); // Run the function
        auto end = high_resolution_clock::now();
        auto duration = duration_cast<milliseconds>(end - start);

        std::cout << "Benchmark \"" << name << "\": " << duration.count() << " ms\n";
    }
};

#endif 
